#!/usr/bin/env python

import sys
import math

from collections import defaultdict

logs = sys.stderr

class Heap(object):
	
	def __init__(self):
		self.heapsize = 0

	def parent(self, i):
		return i/2

	def left(self, i):
		return 2*i+1

	def right(self, i):
		return 2*(i+1)

	def heapify(self, A, i):
		l = self.left(i)
		r = self.right(i)
		largest = 0
		if l < self.heapsize and A[l] >= A[i]:
			largest = l
		else:
			largest = i
		if r < self.heapsize and A[r] >= A[largest]:
			largest = r
		if largest != i:
			A[i], A[largest] = A[largest], A[i]
			self.heapify(A, largest)
	
	def build_heap(self, A):
		self.heapsize = len(A)
		for i in range(int(math.floor(len(A)/2)-1),-1,-1):
			self.heapify(A, i)

	def heap_sort(self, A):
		self.build_heap(A)
		for i in range(len(A)-1, 0, -1):
			A[0], A[i] = A[i], A[0]
			self.heapsize = self.heapsize - 1
			self.heapify(A,0)
		A.reverse()
		print "after heap sort arr::"

	def extract_max(self, A):
		if self.heapsize < 1:
			return None
		maxVal = A[0]
		A[0] = A[self.heapsize-1]
		self.heapsize = self.heapsize - 1
		self.heapify(A, 0)
		return maxVal

	def len_queue(self):
		return self.heapsize

	def insert(self, A, key):
		self.heapsize = self.heapsize + 1
		A.append(-sys.maxint-1)
		self.increase_key(A, self.heapsize-1, key)
	
	def increase_key(self, A, i, key):
		if key < A[i]:
			print >> logs, "error , key must me larger than current key to increase"
		A[i] = key
		while i > 0 and A[self.parent(i)] < A[i]:
			A[i], A[self.parent(i)] = A[self.parent(i)], A[i]
			i = self.parent(i)
		
	def print_heap(self, A):
		print A[:self.heapsize]
    
if __name__ == "__main__":
	A = [5,9,2,1,3]
	q = Heap()
	q.build_heap(A)
	q.print_heap(A)
	q.insert(A, 10)
	q.print_heap(A)
	while q.extract_max(A) is not None:
		q.print_heap(A)
